# This file was automatically generated by SWIG (http://www.swig.org).
# Version 3.0.0
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.





from sys import version_info
if version_info >= (2,6,0):
    def swig_import_helper():
        from os.path import dirname
        import imp
        fp = None
        try:
            fp, pathname, description = imp.find_module('_madoka', [dirname(__file__)])
        except ImportError:
            import _madoka
            return _madoka
        if fp is not None:
            try:
                _mod = imp.load_module('_madoka', fp, pathname, description)
            finally:
                fp.close()
            return _mod
    _madoka = swig_import_helper()
    del swig_import_helper
else:
    import _madoka
if version_info < (3,):
    range = xrange
del version_info
try:
    _swig_property = property
except NameError:
    pass # Python < 2.2 doesn't have 'property'.
def _swig_setattr_nondynamic(self,class_type,name,value,static=1):
    if (name == "thisown"): return self.this.own(value)
    if (name == "this"):
        if type(value).__name__ == 'SwigPyObject':
            self.__dict__[name] = value
            return
    method = class_type.__swig_setmethods__.get(name,None)
    if method: return method(self,value)
    if (not static):
        self.__dict__[name] = value
    else:
        raise AttributeError("You cannot add attributes to %s" % self)

def _swig_setattr(self,class_type,name,value):
    return _swig_setattr_nondynamic(self,class_type,name,value,0)

def _swig_getattr(self,class_type,name):
    if (name == "thisown"): return self.this.own()
    method = class_type.__swig_getmethods__.get(name,None)
    if method: return method(self)
    raise AttributeError(name)

def _swig_repr(self):
    try: strthis = "proxy of " + self.this.__repr__()
    except: strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)

try:
    _object = object
    _newclass = 1
except AttributeError:
    class _object : pass
    _newclass = 0

def bit_scan_reverse(*args):
  return _madoka.bit_scan_reverse(*args)
bit_scan_reverse = _madoka.bit_scan_reverse
MADOKA_LINE_STR = _madoka.MADOKA_LINE_STR

FILE_CREATE    = 1 << 0
FILE_TRUNCATE  = 1 << 1
FILE_READONLY  = 1 << 2
FILE_WRITABLE  = 1 << 3
FILE_SHARED    = 1 << 4
FILE_PRIVATE   = 1 << 5
FILE_ANONYMOUS = 1 << 6
FILE_HUGETLB   = 1 << 7
FILE_PRELOAD   = 1 << 8

SKETCH_EXACT_MODE = _madoka.SKETCH_EXACT_MODE
SKETCH_APPROX_MODE = _madoka.SKETCH_APPROX_MODE
class Sketch(_object):
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, Sketch, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, Sketch, name)
    __repr__ = _swig_repr
    def __init__(self, width=0, max_value=0, path=None, flags=0, seed=0): 
        this = _madoka.new_Sketch()
        try: self.this.append(this)
        except: self.this = this
        return _madoka.Sketch_create(self, width, max_value, path, flags, seed)
    __swig_destroy__ = _madoka.delete_Sketch
    __del__ = lambda self : None;

    def __len__(self):
        return self.file_size()

    def __add__(self, given_sketch):
        """Get merged sketch
        summed_sketch = sketch + sketch
        Param:
            <Sketch> given_sketch
        Return:
            <Sketch> summed_sketch
        """
        summed_sketch = Sketch(width=self.width(), max_value=self.max_value(), seed=self.seed())
        summed_sketch.copy(self)
        _madoka.Sketch_merge(summed_sketch, given_sketch)
        return summed_sketch

    def __iadd__(self, given_sketch):
        """Merge sketch
        sketch += sketch
        Param:
            <Sketch> given_sketch
        Return:
            <Sketch> sketch
        """
        _madoka.Sketch_merge(self, given_sketch)
        return self

    def create(self, width=0, max_value=0, path=None, flags=0, seed=0):
        """Create new sketch
        Params:
            <int> width
            <int> max_value
            <str> path            
            <int> flags
            <int> seed
        """
        return _madoka.Sketch_create(self, width, max_value, path, flags, seed)

    def open(self, *args):
        """Load sketch from file

        open() uses memory mapped I/O instead of reading the whole sketch into memory

        file_flag as following:
            FILE_CREATE    = 0,
            FILE_TRUNCATE  = 1,
            FILE_READONLY  = 2,
            FILE_WRITABLE  = 3,
            FILE_SHARED    = 4,
            FILE_PRIVATE   = 5,
            FILE_ANONYMOUS = 6,
            FILE_HUGETLB   = 7,
            FILE_PRELOAD   = 8

        Params:
            <str> filepath
            <int> file_flag
        """
        _madoka.Sketch_open(self, *args)

    def close(self):
        return _madoka.Sketch_close(self)

    def load(self, *args):
        """Load sketch from file

        file_flag as following:
            FILE_CREATE    = 0,
            FILE_TRUNCATE  = 1,
            FILE_READONLY  = 2,
            FILE_WRITABLE  = 3,
            FILE_SHARED    = 4,
            FILE_PRIVATE   = 5,
            FILE_ANONYMOUS = 6,
            FILE_HUGETLB   = 7,
            FILE_PRELOAD   = 8

        Params:
            <str> filepath
            <int> file_flag
        """
        return _madoka.Sketch_load(self, *args)

    def save(self, *args):
        """Save sketch to file

        file_flag as following:
            FILE_CREATE    = 0,
            FILE_TRUNCATE  = 1,
            FILE_READONLY  = 2,
            FILE_WRITABLE  = 3,
            FILE_SHARED    = 4,
            FILE_PRIVATE   = 5,
            FILE_ANONYMOUS = 6,
            FILE_HUGETLB   = 7,
            FILE_PRELOAD   = 8

        Params:
            <str> filepath
            <int> file_flag
        """
        return _madoka.Sketch_save(self, *args)

    def __getitem__(self, key):
        """
        Param:
            <str> key
        Return:
            <int> value
        """
        return _madoka.Sketch_get(self, key, len(key))

    def __setitem__(self, key, value):
        """
        Param:
            <str> key
            <int> value
        """
        return _madoka.Sketch_set(self, key, len(key), value)

    def __contains__(self, key):
        """
        Param:
            <str> key
        Return:
            <bool>
        """
        return _madoka.Sketch_get(self, key, len(key)) > 0

    def get(self, key, key_length=0):
        """Add key-value
        Params:
            <str> key
            <int> key_length
        Return:
            <int> key_value
        """        
        if key_length < 1:
            key_length = len(key)
        return _madoka.Sketch_get(self, key, key_length)

    def set(self, key, value, key_length=0):
        """Set value to key-value
        Params:
            <str> key
            <int> value
            <int> key_length
        Return:
            <int> key_value
        """        
        if key_length < 1:
            key_length = len(key)
        return _madoka.Sketch_set(self, key, key_length, value)

    def inc(self, key, key_length=0):
        """Increment key-value
        Params:
            <str> key
            <int> key_length
        Return:
            <int> key_value
        """
        if key_length < 1:
            key_length = len(key)
        return _madoka.Sketch_inc(self, key, key_length)

    def add(self, key, value, key_length=0):
        """Add value to key-value
        Params:
            <str> key
            <int> value
            <int> key_length
        Return:
            <int> key_value
        """
        if key_length < 1:
            key_length = len(key)
        return _madoka.Sketch_add(self, key, key_length, value)

    def clear(self):
        """Clear sketch"""
        return _madoka.Sketch_clear(self)

    def copy(self, *args):
        """Copy this sketch
        Return:
            <Sketch> sketch
        """
        return _madoka.Sketch_copy(self, *args)

    def shrink(self, src, width=0, max_value=0, filter=None, path=None, flags=0):
        """Shrink sketch
        Params:
            <Sketch> src_sketch
            <int> width
            <int> max_value
            <lambda> | <function> lhs_filter
            <str> path
            <int> flags
        """
        if filter:
            get_ = _madoka.Sketch__get_
            set_ = _madoka.Sketch__set_
            new_sketch = Sketch(width, max_value, path, flags, src.seed())
            for table_id in range(SKETCH_DEPTH):
                for offset in range(width, src.width(), width):
                    for cell_id in range(width):
                        val = get_(src, table_id, offset + cell_id)
                        val = filter(val)
                        val = max_value if val > max_value else val
                        if val > get_(new_sketch, table_id, cell_id):
                            set_(new_sketch, table_id, cell_id, val)
            self.swap(new_sketch)
        else:
            _madoka.Sketch_shrink(self, src, width, max_value, filter, path, flags)

    def merge(self, rhs, lhs_filter=None, rhs_filter=None):
        """Merge two sketches
        Params:
            <Sketch> sketch
            <lambda> | <function> lhs_filter
            <lambda> | <function> rhs_filter
        """
        if lhs_filter or rhs_filter:
            get_ = _madoka.Sketch__get_
            set_ = _madoka.Sketch__set_
            max_value = _madoka.Sketch_max_value(self)
            for table_id in range(self.depth()):
                for cell_id in range(self.width()):
                    lhs_val = get_(self, table_id, cell_id)
                    rhs_val = get_(rhs, table_id, cell_id)
                    if lhs_filter:
                        lhs_val = lhs_filter(lhs_val)
                    if rhs_filter:
                        rhs_val = rhs_filter(rhs_val)
                    if (lhs_val >= max_value) or (rhs_val >= (max_value - lhs_val)):
                        lhs_val = self.max_value
                    else:
                        lhs_val += rhs_val
                    set_(self, table_id, cell_id, lhs_val)
        else:
            _madoka.Sketch_merge(self, rhs)

    def swap(self, *args):
        """Swap sketches
        Params:
            <Sketch> sketch
        """
        return _madoka.Sketch_swap(self, *args)

    def inner_product(self, *args):
        """Inner product of two sketches
        Params:
            <Sketch> sketch1
            <Sketch> sketch2
        Return:
            <int> inner_product
        """
        return _madoka.Sketch_inner_product(self, *args)

    def filter(self, given_filter, only_nonzero=False):
        """Apply filter into all values
        Params
            <lambda> | <function> given_filter
            <bool> only_nonzero
        """
        get_ = _madoka.Sketch__get_
        set_ = _madoka.Sketch__set_
        max_value = _madoka.Sketch_max_value(self)
        for table_id in range(self.depth()):
            for cell_id in range(self.width()):
                val = get_(self, table_id, cell_id)
                if only_nonzero is False or (only_nonzero and val > 0):
                    val = given_filter(val)
                    val = val if val <= max_value else max_value
                    set_(self, table_id, cell_id, val)

    def values(self):
        """Dump all values
        Return:
            <generator> <int> val
        """
        table_id = 0
        get = _madoka.Sketch__get_
        for cell_id in range(_madoka.Sketch_width(self)):
            val = get(self, table_id, cell_id)
            if val:
                yield val

    def width(self): return _madoka.Sketch_width(self)
    def width_mask(self): return _madoka.Sketch_width_mask(self)
    def depth(self): return _madoka.Sketch_depth(self)
    def max_value(self): return _madoka.Sketch_max_value(self)
    def value_mask(self): return _madoka.Sketch_value_mask(self)
    def value_size(self): return _madoka.Sketch_value_size(self)
    def seed(self): return _madoka.Sketch_seed(self)
    def table_size(self): return _madoka.Sketch_table_size(self)
    def file_size(self): return _madoka.Sketch_file_size(self)
    def flags(self): return _madoka.Sketch_flags(self)
    def mode(self): return _madoka.Sketch_mode(self)
Sketch_swigregister = _madoka.Sketch_swigregister
Sketch_swigregister(Sketch)
cvar = _madoka.cvar
SKETCH_ID_SIZE = cvar.SKETCH_ID_SIZE
SKETCH_MAX_ID = cvar.SKETCH_MAX_ID
SKETCH_ID_MASK = cvar.SKETCH_ID_MASK
SKETCH_MIN_WIDTH = cvar.SKETCH_MIN_WIDTH
SKETCH_MAX_WIDTH = cvar.SKETCH_MAX_WIDTH
SKETCH_DEFAULT_WIDTH = cvar.SKETCH_DEFAULT_WIDTH
SKETCH_MAX_MAX_VALUE = cvar.SKETCH_MAX_MAX_VALUE
SKETCH_DEFAULT_MAX_VALUE = cvar.SKETCH_DEFAULT_MAX_VALUE
SKETCH_DEPTH = cvar.SKETCH_DEPTH
SKETCH_APPROX_VALUE_SIZE = cvar.SKETCH_APPROX_VALUE_SIZE
SKETCH_OWNER_OFFSET = cvar.SKETCH_OWNER_OFFSET
SKETCH_OWNER_MASK = cvar.SKETCH_OWNER_MASK

# This file is compatible with both classic and new-style classes.


